/*
*----------------------------------------------------------------*
*       Window.H - "Pop Up" Windows Module Interface Header      *
*                                                                *
*               <C>opyright 1989,1990 by iHn Systems             *
*                         P.O. Box 4436                          *
*                    Pocatello, Idaho 83205-4436                 *
*                                                                *
*----------------------------------------------------------------*/
#ifdef __TINY__ or __SMALL__
   #error "TINY and SMALL memory models is are not supported";
#endif

#define MAXWINDOW 60

enum StatusType  {Closed=0,Open=1,Hide=2};
enum wscrolltype {W_OFF=0,W_UP=1,W_DOWN=2};

typedef struct {
       enum          StatusType Status;
       int           Handel;
       char          Name[81];
       char          Order,
                     Row,
                     Col,
                     Len,
                     Lines,
                     Border,
                     TextBg,
                     TextFg;
       int           CursorX,
                     CursorY;
   #ifndef __MEDIUM__
       void far      *StackAddr2;
   #else
       void          *StackAddr2;
   #endif
       int           StackLen;
       } WindowsType;

extern WindowsType       windary[MAXWINDOW];
extern int               wtable [MAXWINDOW];
extern int  userwindow;

int  windowsinit        (void);
void windowsend         (void);
void changewindow       (char *,int,int,int,int,char*,
                         int,int,int,char*,
                         int,int,int,int,int);
int  definewindow       (int,int,int,int,int,int,int,char*,
                         int,int,int,char*,
                         int,int,int,int,int);
void popwindow          (char *,int);
int  pushwindow         (char *,int,int);
void clearwindow        (char *,int,int,int);
void writewindowline    (char *,int,int,int,int,int,int,char*);
char *readwindowline    (char *,int,int);
char *readwindowfield   (char *,int,int,int,int,int,int,int,char*);
void writewindowfield   (char *,int,int,int,int,int,int,int,int,int,char*);
void erasewindow        (char *,int);
void movewindow         (char *,int,int,int,char);
void shutwindow         (char *,int);
void savewindow         (void);
void openwindow         (char *,int);
void chgwindowbackground(char *Sc,int Length);
void pausewindowupdates (unsigned char);
